TYPE OutputLineType  ' define all output fields in this TYPE
  CustNo     AS   STRING *  8  ' as strings = size of mask
  Fill1      AS   STRING *  3
  DueTotal   AS   STRING * 10
  Fill2      AS   STRING *  1
  DueCurrent AS   STRING * 10
  Fill3      AS   STRING *  1
  Due30      AS   STRING * 10
  Fill4      AS   STRING *  1
  Due60      AS   STRING * 10
  Fill5      AS   STRING *  1
  DueMore    AS   STRING * 10
END TYPE

TYPE CustomerARType  ' the disk file record
  CustNo     AS LONG
  DueCurrent AS SINGLE
  Due30      AS SINGLE
  Due60      AS SINGLE
  DueMore    AS SINGLE
END TYPE

OutputSection:
  DIM CustAR AS CustomerARType  ' create instance of the TYPE
  PHandle% = FREEFILE
  OPEN "SCRN:" FOR OUTPUT AS PHandle%  ' could be file or printer, too
  ARHandle% = FREEFILE
  OPEN "ARFILE.DAT" FOR BINARY AS ArHandle%  ' open source data file

  DO  ' loop through the entire random access file
    GET #ARHandle%, ,CustAR  ' get a record
    IF EOF(ArHandle%) THEN  ' binary mode returns EOF only after reading
      EXIT LOOP
    ELSE  ' output the line
      CALL OutputALine(CustAr, PHandle%)
    END IF
  LOOP

  CLOSE
  END

SUB OutputALine(X AS CustomerARType, Handle%) LOCAL

   DIM OL AS LOCAL OutputLineType
   Mask$ = "##,###.##-"  ' 10 positions

   LSET OL = SPACE$(LEN(OL))  ' clear out any old data
   RSET OL.CustNo     = STR$(X.CustNo)
   RSET OL.DueCurrent = USING$ (Mask$, X.DueCurrent)
   RSET OL.Due30      = USING$ (Mask$, X.Due30)
   RSET OL.Due60      = USING$ (Mask$, X.Due60)
   RSET OL.Duemore    = USING$ (Mask$, X.Duemore)
   RSET OL.DueTotal   = USING$ (Mask$, (X.DueCurrent + X.Due30 _
                     + X.Due60 + X.DueMore))
   PRINT #Handle%, OL

END SUB
