' SList% is the sub list number (1 = customer 1, 2 = customer 2, etc.)
' ARoot&() contains the beginning root of each sub list
' BRoot&() contains the ending root of each sub list
' ItemKey%() contains the key numbers for the list
' Search% is the key number we're looking for
' ALink&() contains the forward (next) links for each item
' StopPlace& is the last list item examined
' Found% is a flag; if true, key was found
' LeftInsert% is a flag: if true, insert item; if false, append item

SUB ReadList(SList%, ARoot&(), BRoot&(), ItemKey%(), Search%, ALink&(), StopPlace&,
Found%, LeftInsert%) PUBLIC

  Found% = 0  ' clear the Found% flag
  StopPlace& = ARoot&(SList%)  ' next item in list to check
  IF StopPlace& = 0 THEN EXIT SUB  ' no entries in this list

  ' is search key past the ending root number?
  IF Search% <= ItemKey%(BRoot&(SList%)) THEN  ' no, look for item in list
    LeftInsert% = -1  ' we'll be inserting the item
    DO
      IF Search% > ItemKey%(StopPlace&) THEN  ' continue searching
        StopPlace& = ALink&(StopPlace&)  ' set stop to next item in list
      ELSE  ' we've found or passed the item we're looking for
        ' is this the item we're looking for?
        IF Search% = ItemKey%(StopPlace&) THEN Found% = -1
        EXIT LOOP
      END IF
    LOOP
  ELSE  ' yes, append new item to list
    StopPlace& = BRoot&(SList%)
    LeftInsert% = 0  ' append item to list
  END IF

END SUB
