' SList% is the sub list number (1 = customer 1, 2 = customer 2, etc.)
' ARoot&() contains the beginning root of each sub list
' BRoot&() contains the ending root of each sub list
' ALink&() contains the forward (next) links for each item
' BLink&() contains the backward (previous) links for each item
' StopPlace& is the last list item examined by ReadList()

SUB Prune(SList%, ARoot&(), BRoot&(), ALink&(), BLink&(), StopPlace&) PUBLIC

  LOCAL PrevLink&, NextLink&

  ' get the links of next and previous items in list
  PrevLink& = BLink&(StopPlace&)
  NextLink& = ALink&(StopPlace&)

  ' update next link of previous item in list
  IF PrevLink& > 0 THEN  ' not first item in list
    ALink&(PrevLink&) = NextLink&
  ELSE  ' now is first item in list
    ARoot&(SList%) = NextLink&
  END IF

  ' update previous link of next item in list
  IF NextLink& > 0 THEN  ' not last item in list
    BLink&(NextLink&) = PrevLink&
  ELSE  ' now is last item in list
    BRoot&(SList%) = PrevLink&
  END IF

END SUB
