' SList% is the sub list number (1 = customer 1, 2 = customer 2, etc.)
' ARoot&() contains the beginning root of each sub list
' BRoot&() contains the ending root of each sub list
' ALink&() contains the forward (next) links for each item
' BLink&() contains the backward (previous) links for each item
' NewPlace& is the list item at which to insert the new item (often taken from null list)
' StopPlace& is the last list item examined by ReadList()
' LeftInsert% is a flag: if true, insert item; if false, append item

SUB Graft(SList%, ARoot&(), BRoot&(), ALink&(), BLink&(), NewPlace&, StopPlace&,
LeftInsert%) PUBLIC

  LOCAL PrevLink&, NextLink&

  ' Graft an item into a list. Often comes from the null list.
  IF ARoot&(SList%) = 0 THEN  ' no items in list yet
    ARoot&(SList%) = NewPlace&  ' make this item the root
    BRoot&(SList%) = NewPlace&
    ALink&(NewPlace&) = 0  ' no next link
    BLink&(NewPlace&) = 0  ' no previous link
    EXIT SUB
  END IF

  ' get the previous and next links
  IF LeftInsert% THEN  ' insert item in list
    PrevLink& = BLink&(StopPlace&)
    NextLink& = StopPlace&
  ELSE  ' append item to list
    PrevLink& = StopPlace&
    NextLink& = ALink&(StopPlace&)
  END IF

  IF PrevLink& > 0 THEN  ' update previous links
    ALink&(PrevLink&) = NewPlace&
  ELSE
    ARoot&(SList%) = NewPlace&
  END IF

  IF NextLink& > 0 THEN  ' update next links
    BLink&(NextLink&) = NewPlace&
  ELSE
    BRoot&(SList%) = NewPlace&
  END IF

  ' update links for this item
  BLink&(NewPlace&) = PrevLink&
  ALink&(NewPlace&) = NextLink&

END SUB
